using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace LD10Tanks
{
    public struct Point3D
    {
        public int X, Y, Z;

        public static Point3D Zero
        {
            get { return new Point3D(0, 0, 0); }
        }

        public static Point3D operator +(Point3D pt1, Point3D pt2)
        {
            return new Point3D(pt1.X + pt2.X, pt1.Y + pt2.Y, pt1.Z + pt2.Z);
        }

        public static Point3D operator -(Point3D pt1, Point3D pt2)
        {
            return new Point3D(pt1.X - pt2.X, pt1.Y - pt2.Y, pt1.Z - pt2.Z);
        }

        public static Point3D operator -(Point3D pt)
        {
            return new Point3D(-pt.X, -pt.Y, -pt.Z);
        }

        public Vector3 Vector3
        {
            get { return new Vector3(X, Y, Z); }
        }

        public Point3D(int x, int y, int z)
        {
            X = x;
            Y = y;
            Z = z;
        }

        public Point3D(Vector3 v)
        {
            X = (int)v.X;
            Y = (int)v.Y;
            Z = (int)v.Z;
        }
    }
}
